#define _INTERP_
#include <reg166.h>

/*** Module-Specific Include File ***/

#include <interp.h>

/* Receives Input Data From Global Variables */

void map_interp(void) using IREGS {

   int x_value_local, y_value_local ;
   int const near *map_base_local ;

   int x_size      ;
   int y_size      ;

   int x_offset ;
   int y_offset ;
   int x_break_point1,x_break_point2 ; 
   int y_break_point1,y_break_point2 ; 

   int map_x1y1 ;
   int const near *mp ;
   int x_temp1,x_temp2 ;

   x_value_local = x_value ;
   y_value_local = y_value ;
   map_base_local = map_base ;

   /* Get Size Of Map */

   x_size = *map_base_local++ ;
   y_size = *map_base_local++ ;

 //  map_base_local += 2 ;
   x_offset = x_size - 1 ; 
   mp = map_base_local + x_offset ;

   /* Locate Upper and Lower X Breakpoints */

   while((x_value_local < *mp) && (x_offset != 0))
      { 
      mp-- ;
      x_offset-- ;
      }

   /* Extract Upper And Lower X-Breakpoints */

   x_break_point1 = *mp++ ;
   x_break_point2 = *mp ;

   x_temp2 = (x_break_point2 - x_break_point1) ;  // bpt2 still in ACC

   /* Safety Check To Prevent Divide By Zero */

   if(x_temp2 == 0) {
      x_temp2++ ;        // Ensure denominator never zero
      }

   /* Check For x_value_local Less Than Bottom Breakpoint Value */

   if((x_offset == x_size - 1) || (x_value_local <= x_break_point1))     
      { 
      x_value_local = x_break_point1 ;
      } 

   x_temp1 = (x_value_local - x_break_point1) ;

   /*** Warning: if x_temp2 = 0, divide by zero could occur ***/
   /*** Likely to happen if x_value_local above highest bpt and y bpt zero is = 
        to highest x bpt - very unlikely ***/
   
   /* Locate Upper And Lower Y Breakpoints */

   /* Check For 1D Map */

   if(y_size != 0)
      {
      y_offset = y_size - 1 ;

      mp = map_base_local + (unsigned int)(x_size + y_offset) ;

      while ((y_value_local < *mp) && (y_offset != 0)) 
         { 
         y_offset-- ;
         mp-- ;
         } 

      /* Extract Upper And Lower Y-Breakpoints */

      y_break_point1 = *mp++ ;
      y_break_point2 = *mp ;
     
      if((y_offset == y_size - 1) || (y_value_local <= y_break_point1)) 
         { 
         y_value_local = y_break_point1 ;
         } 

       /* Get Map Values */

       map_base_local += x_size + y_size + x_size * y_offset + x_offset ;

#define result_y1 x_offset 
#define result_y2 y_offset

#define map_x2y1 y_size  /* y_size no longer used from here on */

       map_x1y1 = *(map_base_local)              ;
       map_x2y1 = *(map_base_local + 1)          ;

     /* Interpolate 2D Map Values */

#define x map_x1y1
#define y map_x2y1
#define n x_temp1
#define d x_temp2

      y -= x ;
      result_y1 = (unsigned int) (x + (int)((((long)n * y))/d)) ;

#define map_x1y2 map_x1y1   /* Re-use RAM */
#define map_x2y2 map_x2y1

        map_x1y2 = *(map_base_local + x_size)     ;
        map_x2y2 = *(map_base_local + x_size + 1) ;

#undef x
#undef y

#define x map_x1y2
#define y map_x2y2

      y -= x ;
      result_y2 = (unsigned int) (x + (int)((((long)n * y))/d)) ;

#undef x
#undef y
#undef n
#undef d

#define x result_y1
#define y result_y2

#define y_temp2 x_temp2

      y_temp2 = (y_break_point2 - y_break_point1) ;

      /* Prevent Divide By Zero */

      if(y_temp2 == 0) {
         y_temp2++ ;
         } 
       
#define n (y_value_local - y_break_point1)
#define d y_temp2 

#define result result_y1     /* Re-use RAM */


      y -= x ;
      result = (unsigned int) (x + (int)((((long)n * y))/d)) ;

     } /* End of 2D Section */
  else
    {

    /* 1D Interpolation Only */

    map_base_local = map_base_local + x_size + x_offset ;

    map_x1y1 = map_base_local[0] ;
    map_x2y1 = map_base_local[1] ;

#undef x
#undef y
#undef n
#undef d
   
#define x map_x1y1
#define y map_x2y1
#define n x_temp1
#define d x_temp2

      y -= x ;
      result = (unsigned int) (x + (int)((((long)n * y))/d)) ;

    } /* End 1D Section */   

   interp_result = result ;
   }
