#define _TUNEMAPS_

#include <interp.h>
#include <tunemaps.h>

/************************************************************************/
/* TUNE CONSTANTS - declared as global                                  */
/************************************************************************/

    int const near default_tune_constants[] =
       {
        /* Overspeed fuel cutout */ 255,
        /* ORFCO speed           */ 39,   /* 1500 rpm    */
        /* run detect count      */ 8,
        /* distributor offset    */ 38,   /* +18 degrees */
        /* throttle_pot offset   */ 16,
        /* Fully Warm Temperature*/ 181,
        /* Cranking inj on angle */ 6,
        /* Closed throttle retard*/ 000,  /* 000 degrees */
        /* CT retard decay fires */ 8,
        /* Idle inj0 fuel trim   */ 0x80,
        /* Idle inj1 fuel trim   */ 0x80,
        /* Idle inj0/1 fuel trim */ 0x80,
        /* Main map fuel trim    */ 0x80,
        /* Minimum fuel PW       */ 39, 
        /* Idle speed setpoint   */ 150,  /* 750 rpm  */
        /* Idle mode upper speed */ 28,   /* 1100 rpm */
        /* Idle mode lower speed */ 24,   /* 950  rpm */
        /* Idle ignition gain    */ 0x00, /* Degrees/rev */
        /* Max_idle_ign_advance  */ 32,   /* 15 degrees  */ 
        /* Max absolute advance  */ 00,   /* 5 Degrees   */
        /* Dummy                 */ 0 
       } ;


   int const near default_map0[] = { 
 
              0x03,0x03,
              0x00,0x80,0xff,
              0x00,0x80,0xff,

              0x00,0x00,0x00,
              0x00,0x00,0x00,
              0x00,0x00,0x00,

            } ;
            

   int const near default_map1[] = { 

              0x03,0x00,
              0x00,0x80,0xff,
            
              0x00,0x80,0xff
  
            } ;
 
   int const near default_map2[] = { 

            0x08,0x08,
            0x00,0x00,0x00,0x09,0x41,0x80,0xC0,0x3FF,
            0x00,0x00,0x13,0x1A,0x26,0x33,0x80,0x3FF,

            0x00,0x00,0x00,0x09,0x41,0x50,0x66,0x3ff,
            0x00,0x00,0x00,0x09,0x41,0x50,0x66,0x486,
            0x00,0x00,0x00,0x00,0x4D,0x63,0x66,0x466,
            0x00,0x00,0x00,0x02,0x4D,0x63,0x66,0x566,
            0x00,0x00,0x00,0x05,0x4A,0x46,0x40,0x640,
            0x00,0x00,0x00,0x08,0x43,0x43,0x3D,0x63A,
            0x00,0x00,0x00,0x00,0x2D,0x4D,0x56,0x64D,
            0x3ff,0x486,0x466,0x566,0x640,0x63a,0x64C,0x7ff

            } ;
            

   int const near default_map3[] = { 

              0x03,0x00,
              0x00,0x80,0xff,
            
              20,31,42         // 260 deg after tdc ref
  
            } ;


   int const near default_map4[] = { 
 
              0x02,0x02,
              0X00,0x3ff,
              0X00,0X3ff,

              0x08,0x08,
              0x08,0x7ff 
            } ;


   int const near default_map5[] = { 
 
              0x03,0x00,
              0x00,0x80,0xff,

              0x00,0x80,0xff
            } ;

